/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	scheme "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KukuVHostsGetter has a method to return a KukuVHostInterface.
// A group's client should implement this interface.
type KukuVHostsGetter interface {
	KukuVHosts(namespace string) KukuVHostInterface
}

// KukuVHostInterface has methods to work with KukuVHost resources.
type KukuVHostInterface interface {
	Create(*v1.KukuVHost) (*v1.KukuVHost, error)
	Update(*v1.KukuVHost) (*v1.KukuVHost, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.KukuVHost, error)
	List(opts metav1.ListOptions) (*v1.KukuVHostList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.KukuVHost, err error)
	KukuVHostExpansion
}

// kukuVHosts implements KukuVHostInterface
type kukuVHosts struct {
	client rest.Interface
	ns     string
}

// newKukuVHosts returns a KukuVHosts
func newKukuVHosts(c *KumoriV1Client, namespace string) *kukuVHosts {
	return &kukuVHosts{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the kukuVHost, and returns the corresponding kukuVHost object, and an error if there is any.
func (c *kukuVHosts) Get(name string, options metav1.GetOptions) (result *v1.KukuVHost, err error) {
	result = &v1.KukuVHost{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kukuvhosts").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KukuVHosts that match those selectors.
func (c *kukuVHosts) List(opts metav1.ListOptions) (result *v1.KukuVHostList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KukuVHostList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kukuvhosts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kukuVHosts.
func (c *kukuVHosts) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("kukuvhosts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a kukuVHost and creates it.  Returns the server's representation of the kukuVHost, and an error, if there is any.
func (c *kukuVHosts) Create(kukuVHost *v1.KukuVHost) (result *v1.KukuVHost, err error) {
	result = &v1.KukuVHost{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("kukuvhosts").
		Body(kukuVHost).
		Do().
		Into(result)
	return
}

// Update takes the representation of a kukuVHost and updates it. Returns the server's representation of the kukuVHost, and an error, if there is any.
func (c *kukuVHosts) Update(kukuVHost *v1.KukuVHost) (result *v1.KukuVHost, err error) {
	result = &v1.KukuVHost{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kukuvhosts").
		Name(kukuVHost.Name).
		Body(kukuVHost).
		Do().
		Into(result)
	return
}

// Delete takes name of the kukuVHost and deletes it. Returns an error if one occurs.
func (c *kukuVHosts) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kukuvhosts").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kukuVHosts) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kukuvhosts").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched kukuVHost.
func (c *kukuVHosts) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.KukuVHost, err error) {
	result = &v1.KukuVHost{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("kukuvhosts").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
